package example.energy.coolemall;

import schedframe.resources.computing.Node;
import schedframe.resources.computing.coolemall.ComputeBox1;
import schedframe.resources.computing.coolemall.NodeGroup;
import schedframe.resources.computing.profiles.energy.EnergyEvent;
import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;
import example.energy.BaseEnergyEstimationPlugin;

public class CB1EnergyEstimationPlugin extends BaseEnergyEstimationPlugin{

	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {
		double powerConsumption = 0;
		ComputeBox1 computeBox1 = (ComputeBox1)resource;
		for(NodeGroup ng:computeBox1.getNodesGroups()){
			try{
				powerConsumption = powerConsumption + ng.getPowerInterface().getRecentPowerUsage().getValue();
			} catch (Exception e){
				
			}
		}
		
		int nrOfPoweredOffNodes = 0;
		for(Node node: computeBox1.getNodes()){
			if(node.getPowerInterface().getPowerState().equals(StandardPowerStateName.OFF)){
				nrOfPoweredOffNodes++;
			}
		}
		if(nrOfPoweredOffNodes != computeBox1.getNodes().size()){
			powerConsumption = (powerConsumption + CoolEmAllTestbedMeasurements.OTHER_DEVICES_POWER_CONSUMPTION)/CoolEmAllTestbedMeasurements.POWER_SUPPLY_EFFICIENCY;			
		}
		return powerConsumption;
	}

}
